/*
**  pilib.h - .pi ɤ߹/񤭽Ф饤֥ ver.3.10 (Sep 6, 2004)
**
**  Copyright (C) 1999-2004 MIYASAKA Masaru <alkaid@coral.ocn.ne.jp>
**
**  This software is provided 'as-is', without any express or implied warranty.
**  In no event will the authors be held liable for any damages arising from
**  the use of this software.
**
**  Permission is granted to anyone to use this software for any purpose,
**  including commercial applications, and to alter it and redistribute it
**  freely, subject to the following restrictions:
**
**  1. The origin of this software must not be misrepresented; you must not
**     claim that you wrote the original software. If you use this software
**     in a product, an acknowledgment in the product documentation would be
**     appreciated but is not required.
**
**  2. Altered source versions must be plainly marked as such, and must not
**     be misrepresented as being the original software.
**
**  3. This notice may not be removed or altered from any source distribution.
**
**  ----
**
**  ܥեȥϡָΤޤޡפǡǤ뤫ۤǤ뤫鷺
**  ݾڤʤ󶡤ޤ ܥեȥλѤˤä뤤ʤ»
**  ĤƤ⡢ԤϰڤǤʤΤȤޤ
**
**  ʲ¤˽¤ꡢѥץꥱޤơܥեȥǤդ
**  Ū˻Ѥͳ˲Ѥƺۤ뤳Ȥ򤹤٤Ƥοͤ˵Ĥޤ
**
**  1. ܥեȥνмˤĤƵɽ򤷤ƤϤʤޤ
**     ʤꥸʥΥեȥȼĥƤϤʤޤ
**     ʤܥեȥǻѤ硢ʤʸ˼ռ
**     йǤɬܤǤϤޤ
**
**  2. ѹϡΤȤʤФʤޤ󡣥ꥸʥ
**     ΥեȥǤȤɽ򤷤ƤϤʤޤ
**
**  3. ʪ顢ɽꡢɽƤѹꤷƤ
**     ʤޤ
**
**  ----
**
**  NOTE: Comments are written in Japanese. Sorry.
*/

#ifndef PILIB_H
#define PILIB_H

/* -----------------------------------------------------------------------
**		Basic functions
*/

#include <limits.h>		/* for CHAR_BIT */
#include <stddef.h>		/* for size_t & ptrdiff_t */

#if 0	/* Use Win32-API functions */

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#define pi_memmove			MoveMemory
#define pi_memcpy			CopyMemory
#define pi_memset(d,c,l)	FillMemory((d),(l),(c))
#define pi_malloc(s)		((pi_voidp)LocalAlloc(LMEM_FIXED,(s)))
#define pi_free(s)			LocalFree((HLOCAL)(s))

#else	/* Use standad C library functions */

#include <stdlib.h>
#include <string.h>

#define pi_memmove			memmove
#define pi_memcpy			memcpy
#define pi_memset			memset
#define pi_malloc			malloc
#define pi_free				free

#endif

/* -----------------------------------------------------------------------
**		Configurations
*/

	/* Ƽư */
#define PI_SUPPORT_LONGJMP				/* longjmp() Ȥäƥ顼򤹤 */
#define PI_SUPPORT_PROGRESS_CALLBACK 	/* ХåؿѲǽˤ */

#define PI_READ_SKIP_MACBINARY			/* Ƭ MacBinary ɤФ */
#define PI_READ_SUPPORT_STDIO			/* ɸॹȥ꡼ϤΥݡ */
#define PI_READ_SUPPORT_EXTINFO			/* إåγĥ */
#define PI_READ_SUPPORT_COMMENT			/* ¢ƥȤ */
#define PI_READ_SUPPORT_READIMAGE		/* pi_read_image() Ѳǽˤ */
#undef PI_READ_OUTPUT_8BPP_FMT			/*  8bit/pixel ǽϤ */

#define PI_WRITE_SUPPORT_STDIO			/* ɸॹȥ꡼ϤΥݡ */
#define PI_WRITE_SUPPORT_EXTINFO 		/* إåγĥꤹ */
#define PI_WRITE_SUPPORT_COMMENT 		/* ¢ƥȤꤹ */
#define PI_WRITE_SUPPORT_WRITEIMAGE		/* pi_write_image() Ѳǽˤ */
#undef PI_WRITE_INPUT_8BPP_FMT			/*  8bit/pixel Ϥ */

#define PI_CALL_USING_FASTCALL			/* ؿ fastcall ƤӽФȤ */
#define PI_INIT_STRUCT_BY_MEMSET 		/* pi_memset() ǹ¤Τ */
#undef PI_WORD_OPERATION_ON_PIXEL		/* 16ӥåñ̤ǥԥ򰷤 */
#define PI_WRITE_PUTBITS_FUNC			/* ؿǤΥӥåȽϥ롼Ȥ */

	/* 2pixelʲβPiͽ(PITECH.TXT)˽񤫤ƤȤ
	 * 󥳡ɡǥɤˤϡʲΥޥ #define ޤ
	 * ܤ piwrite.c Ρ2pixelʲβνˡפ򸫤
	 * äͳΤʤ¤ #undef ˤƤȤᤷޤ*/
#undef PI_READ_W2_SPEC_COMPLIANT_DECODING
#undef PI_WRITE_W2_SPEC_COMPLIANT_ENCODING



/* ***********************************************************************
**		Pi format encoding/decoding library (piwrite.c/piread.c)
*/

	/* ǥեȤΥ顼(ǽ) */
#ifndef PI_OK
#define PI_OK						0		/*  */
#define PI_ERR_NOT_A_PI				1		/* .PIեǤϤʤ */
#define PI_ERR_INVALID_BITDEPTH		2		/* ̵ʿ(4,8 ʳ) */
#define PI_ERR_INVALID_WIDTH		3		/* ̵(0 or 65535Ķ) */
#define PI_ERR_INVALID_HEIGHT		4		/* ̵ʹ⤵(0 or 65535Ķ) */
#define PI_ERR_FILE_WRITE			5		/* ե񤭹ߥ顼 */
#define PI_ERR_FILE_READ			6		/* եɤ߹ߥ顼 */
#define PI_ERR_END_OF_FILE			7		/* ե뽪ü򸡽 */
#define PI_ERR_OUT_OF_MEMORY		8		/* ­ */
#define PI_ERR_CALLBACK_CANCELED	9		/* ԥХåؿˤ */
#endif

	/* Ƽե饰ʤ */
#define PI_FLAG_NO_COMMENT		0x0001		/* Ȥʤ */
#define PI_FLAG_MISSING_SIG		0x0002		/* եƬ "Pi" ʤ */
#define PI_MODE_NO_PALETTE		0x80		/* ǥեȥѥåȻѲ */
#define PI_TRANSCOLOR_NONE		(-1)		/* Ʃʤλؼ */

	/* 顼ѥޥ */
#ifdef PI_SUPPORT_LONGJMP
	/* setjmp()  longjmp() ˤˡ */
#include <setjmp.h>		/* setjmp() & longjmp() */
#define PI_ISERR(p)     (0)
#define PI_RESETERR(p)
#define PI_CHKERR_RETURN(p)
#define PI_CHKERR_RETURN_VAL(p,r)
#define PI_SETERR_RETURN(p,e)        longjmp((p)->jmpbuf,(e))
#define PI_SETERR_RETURN_VAL(p,e,r)  longjmp((p)->jmpbuf,(e))
#else
	/* ѿ error ͤ򸫤ʤ缡 return Ƥˡ */
#define PI_ISERR(p)     ((p)->error!=PI_OK)
#define PI_RESETERR(p)  ((p)->error=PI_OK)
#define PI_CHKERR_RETURN(p) \
            do { if (PI_ISERR(p)) return; } while (0)
#define PI_CHKERR_RETURN_VAL(p,r) \
            do { if (PI_ISERR(p)) return (r); } while (0)
#define PI_SETERR_RETURN(p,e) \
            do { if (!PI_ISERR(p)) (p)->error=(e); return; } while (0)
#define PI_SETERR_RETURN_VAL(p,e,r) \
            do { if (!PI_ISERR(p)) (p)->error=(e); return (r); } while (0)
#endif /* PI_SUPPORT_LONGJMP */

	/* ΥХȿ׻ޥ */
#ifdef PI_READ_OUTPUT_8BPP_FMT
#define pi_read_get_rowbytes(p) ((p)->width)
#else
#define pi_read_get_rowbytes(p) \
            (((p)->bitdepth == 8) ? (p)->width : ((pi_uint32)(p)->width+1)/2)
#endif

	/* piread.c / piwrite.c ǤΤ߻Ȥޥ */
#ifdef PI_INTERNAL

	/* FASTCALL ƤӽФ */
#undef FASTCALL
#ifdef PI_CALL_USING_FASTCALL
#if defined(__GNUC__) && defined(__i386__)			/* gcc (on i386) */
#define FASTCALL  __attribute__((regparm(3)))
#elif defined(_MSC_VER) || defined(__BORLANDC__)	/* MS-C or BCC */
#define FASTCALL  __fastcall
#endif
#endif /* PI_CALL_USING_FASTCALL */
#ifndef FASTCALL
#define FASTCALL
#endif

	/* ѿ/Υӥåȿ */
#define bitsof(x)	(sizeof(x) * CHAR_BIT)

#endif /* PI_INTERNAL */

	/* typedef's */
typedef char           pi_char;		/* signed or unsigned */
typedef unsigned char  pi_byte;
typedef int            pi_int;
typedef unsigned int   pi_uint;
typedef short          pi_int16;
typedef unsigned short pi_uint16;
typedef long           pi_int32;
typedef unsigned long  pi_uint32;

typedef unsigned int pi_bitbuf;		/* unsigned  16bit ʾ */
typedef size_t       pi_size_t;
typedef ptrdiff_t    pi_ptrdif_t;

typedef void      * pi_voidp;
typedef pi_char   * pi_charp;
typedef pi_byte   * pi_bytep;
typedef pi_int    * pi_intp;
typedef pi_uint   * pi_uintp;
typedef pi_int16  * pi_int16p;
typedef pi_uint16 * pi_uint16p;
typedef pi_int32  * pi_int32p;
typedef pi_uint32 * pi_uint32p;
typedef pi_bytep  * pi_bytepp;

typedef struct pi_struct   pi_struct;
typedef struct pi_struct * pi_structp;
typedef struct pi_text     pi_text;
typedef struct pi_text   * pi_textp;
typedef struct pi_stdio    pi_stdio;
typedef struct pi_stdio  * pi_stdiop;

typedef pi_size_t (*pi_iofncp)(pi_structp);
typedef pi_int (*pi_progfncp)(pi_structp, pi_uint, pi_uint);

	/* ѥåѥ顼¤(ǥե) */
#ifndef PI_COLOR_DEFINED
#define PI_COLOR_DEFINED
typedef struct pi_color {
	pi_byte		red;
	pi_byte		green;
	pi_byte		blue;
} pi_color;
#endif
typedef pi_color * pi_colorp;

	/* øɸ I/O ˤϥݡѹ¤ */
#ifdef PI_READ_SUPPORT_STDIO
#include <stdio.h>
struct pi_stdio {
	FILE		*fp;			/* ϥȥ꡼ */
	pi_byte		iobuf[4096];	/* ϥХåե */
};
#endif

	/* ¢ݻѹ¤ */
#ifdef PI_READ_SUPPORT_COMMENT
struct pi_text {
	pi_textp	next;		/* ؤΥݥ */
	pi_uint32	size;		/* ¢ƥȤΥ */
	pi_charp	text;		/* ¢ƥ */
};
#endif

	/* pi_struct ¤ */
struct pi_struct {
		/* 顼ѿ */
#ifdef PI_SUPPORT_LONGJMP
	jmp_buf		jmpbuf;				/* setjmp() / longjmp() ѥƥ */
#else
	pi_int		error;				/* 顼 */
#endif
		/* .PIեإåƼ */
	pi_uint		width, height;		/* Υ */
	pi_uint		colors;				/* (16 or 256) */
	pi_byte		bitdepth;			/* (4 or 8) */
	pi_byte		aspect_x, aspect_y;	/* ڥ */
	pi_byte		mode;				/* ⡼ */
	pi_byte		machine[4];			/* Ｑ̻(󥳡̾) */

		/* I/O ط */
	pi_iofncp	iofunc;				/* I/O ؿ */
	pi_voidp	ioptr;				/* I/O ؿѥݥ */
	pi_bytep	iobufptr;			/* I/O ХåեΥݥ */
	pi_size_t	iobufcnt;			/* I/O ХåեλĤХȿ */
	pi_bitbuf	bitbuf;				/* ӥåȥХåե */
	pi_uint		bitcnt;				/* ӥåȥХåեλĤӥåȿ */

		/* ΰ衦ѿ */
	pi_bytep	clrtable;			/* 顼ơ֥ */
	pi_bytep	clrcode;			/* 顼ɥơ֥ */
	pi_bytep	clrcodelen;			/* 顼ɤĹ */
	pi_bytep	lencode;			/* Ϣɥơ֥ */
	pi_bytep	lencodelen;			/* ϢɤĹ */

	pi_uint		prevpos;			/* ΰ֥ */
	pi_uint		savedpos;			/* ߤΰ֥ */
	pi_uint32	savedlen;			/* ߤϢ */

	pi_bytep	rowbuf;				/* ԥХåե */
	pi_bytep	rowptr[4];			/* ԤƬɥ쥹 */
	pi_bytep	rowend;				/* Ԥνüɥ쥹 */
	pi_bytep	currentp;			/* ߤιԤ */
	pi_uint		rownum;				/* ߤιԤιֹ (1height) */
	pi_ptrdif_t	posdiff[6];			/* ֥ɤбХɥ쥹 */

		/* .PIեإåγĥ */
#if defined(PI_READ_SUPPORT_EXTINFO) || defined(PI_WRITE_SUPPORT_EXTINFO)
	pi_uint		offset_x, offset_y;	/* ɽ(եå) */
	pi_int		transcolor;			/* Ʃˤʤѥåֹ (015/255) */
	pi_int		sigbits;			/* ѥåȤͭӥåȿ (18) */
	pi_int		colorused;			/* ѥåȤλѸĿ (116/256) */
#endif
		/* ¢ƥȾ */
#if defined(PI_READ_SUPPORT_COMMENT) || defined(PI_WRITE_SUPPORT_COMMENT)
	pi_text		comment;			/* ¢ƥȥХåե */
#endif
		/* Хåؿ */
#ifdef PI_SUPPORT_PROGRESS_CALLBACK
	pi_progfncp	progfunc;			/* Хåؿ */
	pi_voidp	progptr;			/* Хåؿѥݥ */
#endif
};

	/* ץȥ (piread.c) */
void pi_read_init(pi_structp);
void pi_read_end(pi_structp);
void pi_read_header(pi_structp, pi_uint);
#ifdef PI_READ_SUPPORT_COMMENT
void pi_read_get_comment(pi_structp, pi_charp, pi_int);
#endif
void pi_read_palette(pi_structp, pi_colorp);
void pi_read_row_init(pi_structp);
int pi_read_row(pi_structp, pi_bytep);
#ifdef PI_READ_SUPPORT_READIMAGE
void pi_read_image(pi_structp, pi_bytepp);
#endif
#ifdef PI_READ_SUPPORT_STDIO
void pi_read_init_io(pi_structp, FILE *);
void pi_read_end_io(pi_structp);
#endif

	/* ץȥ (piwrite.c) */
void pi_write_init(pi_structp);
void pi_write_end(pi_structp);
void pi_write_header(pi_structp);
void pi_write_palette(pi_structp, pi_colorp /*, pi_int*/);
void pi_write_row_init(pi_structp);
int pi_write_row(pi_structp, pi_bytep);
#ifdef PI_WRITE_SUPPORT_WRITEIMAGE
void pi_write_image(pi_structp, pi_bytepp);
#endif
#ifdef PI_WRITE_SUPPORT_STDIO
void pi_write_init_io(pi_structp, FILE *);
void pi_write_end_io(pi_structp);
#endif

#endif /* PILIB_H */
